part of tecfy_core_client_package;

class TecfySyncService {
  static get isOfflineMode {
    return !kIsWeb &&
        (ConnectionService.isOffline ||
            ConnectionService.activeConnection?.isCloud == true);
  }

  static Future<int> getUnpostedCount() async {
    var unPosted = await DatabaseService.rawQuery(
        'select count(*) from Entity where isPosted = 0');
    if (unPosted.length == 0) return -1;

    return unPosted.first.values.first;
  }

  static Future<bool> pushNow() async {
    try {
      if (kIsWeb || ConnectionService.isOffline) {
        return true;
      }

      print('++++++++++++++++++++++++++++++++ Start Sync');
      var unPosted =
          (await DatabaseService.query('Entity', where: 'isPosted = 0'))
              .toList();
      print('SSSSSSSSSSSSS-------------- unPosted to sync ${unPosted.length}');
      if (unPosted.length == 0) return true;

      var modelsResult = await ApiService.httpGetDynamic('Sync/getModels');
      if (!modelsResult.success) return false;

      var models = modelsResult.data;
      print(models);
      //===========
      //== Post un-posted items
      //===========

      for (var model in models) {
        model = EntityService.lowerFirst(model);
        print('=============== start $model');
        for (var item in unPosted.where((e) => e['entity'] == model)) {
          print(item['id']);
          var result = await ApiService.httpPostEx(
              'entity/addupdate/$model',
              jsonEncode(jsonDecode(item['body']),
                      toEncodable: EntityService.customEncode)
                  .replaceAll('\"', '\''));
          if (result.success) {
            await DatabaseService.update('Entity', {'isPosted': 1},
                where: 'id = ?', whereArgs: [item['id']]);
          } else {
            print(result.toString());
          }
        }
      }
      return true;
    } catch (err) {
      print(err);
    }
  }

  static Future<bool> syncNow() async {
    if (kIsWeb) {
      return true;
    }
    await pushNow();

    //===========
    //== Load Item category
    //===========
    // var categoryResult =
    //     await ApiService.httpGetDynamic('pos/GetItemCategorySecondry');

    // if (categoryResult.success) {
    //   var items = (categoryResult.data as List<dynamic>)
    //       .map<ItemCategory>((e) => ItemCategory.fromJson(e, null))
    //       .toList();

    //   await DatabaseService.delete('ItemCategory');

    //   await DatabaseService.exeBatch((batch) async {
    //     for (var item in items) {
    //       batch.insert('ItemCategory', item.toJson());
    //     }
    //     return true;
    //   });
    //   print(
    //       '+++++++++++++++++++ ItemCategory count ${(await DatabaseService.rawQuery('select count(*) from ItemCategory'))}');
    // } else {
    //   print('XXXX Error ItemCategory ${categoryResult.message} ');
    // }

    return true;
  }
}
