part of tecfy_core_client_package;

class ReportListPage extends StatefulWidget {
  @override
  _ReportListPageState createState() => _ReportListPageState();
}

class _ReportListPageState extends State<ReportListPage> {
  List<dynamic> reports;

  @override
  void initState() {
    getData();
    super.initState();
  }

  getData() async {
    var result = await ApiService.httpGetDynamic('Report/GetList');
    print(result.data);
    if (result.success) {
      setState(() {
        reports = result.data;
      });
    }
  }

  onPressed(report) async {
    // AppNavigator.navigateTo(context, ()=>ReportFilterPage(report));
    var result = await AppNavigator.navigateTo(
        context,
        () => EntityFilterPage(
            report['name${LocalConfigService.languagePrefex}'],
            report['filters']
                .map<Property>((r) => Property.getProperty(r))
                .toList()),
        animationType: AnimationTypes.slideLeft);
    bool canceled = false;
    if (result == null) canceled = true;
    var filter = (result as List<EntityFilter>)
        .where((f) =>
            f.value != null && f.property != null && f.operatorId != null)
        .toList();

    if (!canceled) {
      AppNavigator.navigateTo(context, () => ReportDetailPage(report, filter));
    } else {
      Navigator.pop(context);
    }
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(
      context,
      'Reports',
      child: reports == null
          ? Center(
              child: CircularProgressIndicator(
                  valueColor:
                      AlwaysStoppedAnimation<Color>(ThemeService.mainColor)))
          : ListView(
              children: reports
                  .map<Widget>(
                    (report) => Container(
                      alignment: Alignment.center,
                      child: Container(
                        height: 50,
                        constraints: BoxConstraints(maxWidth: 300),
                        padding: EdgeInsets.all(5),
                        child: RaisedButton(
                          shape: RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(5)),
                          padding: EdgeInsets.all(5),
                          color: ThemeService.mainColor,
                          onPressed: () => onPressed(report),
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.start,
                            children: <Widget>[
                              SizedBox(width: 5),
                              // isBussy
                              //     ? Transform.scale(
                              //         scale: 0.5,
                              //         child: CircularProgressIndicator(
                              //           valueColor: AlwaysStoppedAnimation<Color>(
                              //               ThemeService.textOnMainColor),
                              //         ))
                              //     :
                              Transform.scale(
                                  scale: 0.8,
                                  child:
                                      Icon(Icons.print, color: Colors.white)),
                              SizedBox(width: 5),
                              Text(
                                report['name${LocalConfigService.languagePrefex}'] ??
                                    'N/A',
                                style: TextStyle(
                                    color: ThemeService.textOnMainColor),
                              )
                            ],
                          ),
                        ),
                      ),
                    ),
                  )
                  .toList(),
            ),
    );
  }
}
